#include <gba_console.h>
#include <gba_video.h>
#include <gba_interrupt.h>
#include <gba_systemcalls.h>
#include <gba_input.h>
#include <gba_sio.h>
#include <stdio.h>
#include <stdlib.h>

void serial_init() {
    REG_RCNT = 0;
    REG_SIOCNT = SIO_32BIT | SIO_SO_HIGH;
}

void serial_rawsend(u32 value) {
    REG_SIODATA32 = value;
    REG_SIOCNT = SIO_32BIT;
    REG_SIOCNT = SIO_32BIT | SIO_SO_HIGH | SIO_START;
    while (REG_SIOCNT & SIO_START) {}
}

u32 mem_read(u32, u32, u32);

int main(void) {
    irqInit();
    irqEnable(IRQ_VBLANK);

    consoleDemoInit();

    iprintf("GBA BIOS Dumper\n");
    iprintf("Please run recver on PC\n\n");
    serial_init();

    for (size_t addr = 0; addr < 0x4000; addr += 4) {
        irqDisable(IRQ_VBLANK);
        u32 value = mem_read(addr, 0xFFFFFFFD, 0x68006800);
        irqEnable(IRQ_VBLANK);

        for (size_t i = 0; i < 8; ++i) {
            serial_rawsend("0123456789ABCDEF"[(value >> (28 - i * 4)) & 0xF]);
        }
        serial_rawsend('\n');

        iprintf("\x1b[3;0H%d%%", addr * 100 / 0x4000);
    }

    iprintf("\nDone");
    
    for (;;) {
	      VBlankIntrWait();
    }
}
